DAT objectName         byte "ChildExample170114a", 0 ' remember to add a terminating zero
CON '' Version Notes
{{
  170114a This object increments a count and stores the count value in variables defined
  by both this object and the parent object.
  
}}
CON

  
VAR

  long stack[64]
  long childVariable

  'These two variables need to be kept in this order.
  long countInterval
  long parentVariableAddress
  
PUB Start(clockCyclesPerIncrement, parentPtr)

  ' Below is a shortcut to assign multiple longs at once.
  ' This only works is the variables are longs.
  longmove(@countInterval, @clockCyclesPerIncrement, 2)

  ' If you don't understand the line of code above you could instead use the following:
  'countInterval := clockCyclesPerIncrement 
  'parentVariableAddress := parentPtr

  result := cognew(Count, @stack)
  ' Note many objects add one to the cog number returned.
  ' This example does not add one so if the returned value
  ' is negative one, then a cog was not available.
  ' When one is added, a return value of zero indicates no
  ' cog is available.
  
PRI Count | timer

  timer := countInterval + cnt
  repeat
    waitcnt(timer)
    timer += countInterval
    childVariable++
    long[parentVariableAddress]++
    
PUB ChangeParentPointer(newAddress)

  parentVariableAddress := newAddress

PUB GetValue

  result := childVariable

PUB SetOneTimePointer(oneTimePointer)

  long[oneTimePointer] := childVariable

PUB GetAddressOfChildVariable

  result := @childVariable

PUB GetInterval

  result := countInterval

PUB SetInterval(newInterval)

  countInterval := newInterval
  
PUB GetObjectName ' A method I like to add to keep track of versions.

  result := @objectName
         